/* $OpenLDAP: pkg/ldap/include/ldap_config.nt,v 1.2.2.3 2000/07/04 17:58:48 kurt Exp $ */
/*
 * Copyright 1998-2000 The OpenLDAP Foundation, Redwood City, California, USA
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted only
 * as authorized by the OpenLDAP Public License.  A copy of this
 * license is available at http://www.OpenLDAP.org/license.html or
 * in file LICENSE in the top-level directory of the distribution.
 */

/*
 * This file works in confunction with OpenLDAP setup.mak system.
 * If you do no like the values below, adjust your configure options.
 */

#ifndef _LDAP_CONFIG_H
#define _LDAP_CONFIG_H

/* directory separator */
#ifndef LDAP_DIRSEP
#define LDAP_DIRSEP "\\"
#endif

/* directory for temporary files */
#if defined( _P_tmpdir )
#define LDAP_TMPDIR _P_tmpdir
#else
#define LDAP_TMPDIR "\\"
#endif

/* directories */
#ifndef LDAP_PREFIX
#define LDAP_PREFIX			"C:\\OpenLDAP"
#endif
#ifndef LDAP_BINDIR
#define LDAP_BINDIR			LDAP_PREFIX "\\bin"
#endif
#ifndef LDAP_SBINDIR
#define LDAP_SBINDIR		LDAP_PREFIX "\\sbin"
#endif
#ifndef LDAP_DATADIR
#define LDAP_DATADIR		LDAP_PREFIX "\\share"
#endif
#ifndef LDAP_SYSCONFDIR
#define LDAP_SYSCONFDIR		LDAP_PREFIX "\\sysconf"
#endif
#ifndef LDAP_LIBEXECDIR
#define LDAP_LIBEXECDIR		LDAP_PREFIX "\\libexec"
#endif
#ifndef LDAP_RUNDIR
#define LDAP_RUNDIR			LDAP_PREFIX "\\run"
#endif

/* command locations */
#ifndef LDAP_EDITOR
#define LDAP_EDITOR			"%EDITOR%"
#endif
#ifndef LDAP_FINGER
#define LDAP_FINGER			"%FINGER%"
#endif
#ifndef LDAP_SENDMAIL
#define LDAP_SENDMAIL		"%SENDMAIL%"
#endif

#endif /* _LDAP_CONFIG_H */
